# Uses of Class
net.shibboleth.idp.authn.SubjectCanonicalizationFlowDescriptor

Packages that use SubjectCanonicalizationFlowDescriptor
Package
Description
net.shibboleth.idp.authn
APIs related to the authentication of a subject.
net.shibboleth.idp.authn.context
Context classes for managing authentication-related state.
net.shibboleth.idp.authn.impl
Implementation of various authentication actions.
net.shibboleth.idp.saml.nameid
Code for manipulating NameIDs and NameIdentifiers.
net.shibboleth.idp.saml.nameid.impl
Implementation of SAML `NameID` and `NameIdentifier` generation and consumption.

## Uses of SubjectCanonicalizationFlowDescriptor in net.shibboleth.idp.authn

Subclasses of SubjectCanonicalizationFlowDescriptor in net.shibboleth.idp.authn
Modifier and Type
Class
Description
`class`
`AbstractSubjectCanonicalizer`
A base class for "stand-alone" subject c14n implementations.

## Uses of SubjectCanonicalizationFlowDescriptor in net.shibboleth.idp.authn.context

Fields in net.shibboleth.idp.authn.context declared as SubjectCanonicalizationFlowDescriptor
Modifier and Type
Field
Description
`private SubjectCanonicalizationFlowDescriptor`
SubjectCanonicalizationContext.`attemptedFlow`
The last c14 flow attempted.
Fields in net.shibboleth.idp.authn.context with type parameters of type SubjectCanonicalizationFlowDescriptor
Modifier and Type
Field
Description
`private final Map<String,SubjectCanonicalizationFlowDescriptor>`
SubjectCanonicalizationContext.`intermediateFlows`
Previously attempted flows (could be failures or intermediate results).
`private final Map<String,SubjectCanonicalizationFlowDescriptor>`
SubjectCanonicalizationContext.`potentialFlows`
Flows that could potentially be used.
Methods in net.shibboleth.idp.authn.context that return SubjectCanonicalizationFlowDescriptor
Modifier and Type
Method
Description
`SubjectCanonicalizationFlowDescriptor`
SubjectCanonicalizationContext.`getAttemptedFlow()`
Get the last flow that was attempted for subject c14n.
Methods in net.shibboleth.idp.authn.context that return types with arguments of type SubjectCanonicalizationFlowDescriptor
Modifier and Type
Method
Description
`Map<String,SubjectCanonicalizationFlowDescriptor>`
SubjectCanonicalizationContext.`getIntermediateFlows()`
Get the set of flows that have been executed, successfully or otherwise, without producing a completed result.
`Map<String,SubjectCanonicalizationFlowDescriptor>`
SubjectCanonicalizationContext.`getPotentialFlows()`
Get the set of flows that could potentially be used for subject canonicalization.
Methods in net.shibboleth.idp.authn.context with parameters of type SubjectCanonicalizationFlowDescriptor
Modifier and Type
Method
Description
`SubjectCanonicalizationContext`
SubjectCanonicalizationContext.`setAttemptedFlow(SubjectCanonicalizationFlowDescriptor flow)`
Set the last flow that was attempted for subject c14n.

## Uses of SubjectCanonicalizationFlowDescriptor in net.shibboleth.idp.authn.impl

Subclasses of SubjectCanonicalizationFlowDescriptor in net.shibboleth.idp.authn.impl
Modifier and Type
Class
Description
`class`
`AttributeSourcedSubjectCanonicalization`
A `SubjectCanonicalizer` that resolves attributes and then extracts a resolved `IdPAttribute` value from an `AttributeContext` child obtained via lookup function (by default a child of the `SubjectCanonicalizationContext`), and uses it as the result of subject canonicalization.
`class`
`FunctionSubjectCanonicalization`
A `SubjectCanonicalizer` that delegates implementation to a function, allowing scripted/etc.
`class`
`SimpleSubjectCanonicalization`
A `SubjectCanonicalizer` that transforms the input `Subject` into a principal name by searching for one and only one `UsernamePrincipal` custom principal.
`class`
`X500SubjectCanonicalization`
A `SubjectCanonicalizer` that transforms the input `Subject` into a principal name by searching for one and only one `X509Certificate` public credential, or in its absence one and only one `X500Principal`.
Fields in net.shibboleth.idp.authn.impl with type parameters of type SubjectCanonicalizationFlowDescriptor
Modifier and Type
Field
Description
`private Map<String,SubjectCanonicalizationFlowDescriptor>`
PopulateSubjectCanonicalizationContext.`availableFlows`
The flows to make available for possible use.
Methods in net.shibboleth.idp.authn.impl that return SubjectCanonicalizationFlowDescriptor
Modifier and Type
Method
Description
`private SubjectCanonicalizationFlowDescriptor`
SelectSubjectCanonicalizationFlow.`selectUnattemptedFlow(ProfileRequestContext profileRequestContext, SubjectCanonicalizationContext c14nContext)`
Select the first potential flow not found in the intermediate flows collection, and that is applicable to the context.
Method parameters in net.shibboleth.idp.authn.impl with type arguments of type SubjectCanonicalizationFlowDescriptor
Modifier and Type
Method
Description
`void`
PopulateSubjectCanonicalizationContext.`setAvailableFlows(Collection<SubjectCanonicalizationFlowDescriptor> flows)`
Set the flows available for possible use.
`void`
PopulateSubjectCanonicalizationContext.`setAvailableFlows(IdentifiedComponentManager<SubjectCanonicalizationFlowDescriptor> manager)`
Set the flows available for possible use via a manager object.
Constructor parameters in net.shibboleth.idp.authn.impl with type arguments of type SubjectCanonicalizationFlowDescriptor
Modifier
Constructor
Description
``
`SubjectCanonicalizationFlowDescriptorManager(List<SubjectCanonicalizationFlowDescriptor> freeObjects)`
Constructor.

## Uses of SubjectCanonicalizationFlowDescriptor in net.shibboleth.idp.saml.nameid

Subclasses of SubjectCanonicalizationFlowDescriptor in net.shibboleth.idp.saml.nameid
Modifier and Type
Class
Description
`class`
`AbstractNameIDCanonicalizer`
Base class for "inline" implementations of SAML c14n flows.
`class`
`NameIDCanonicalizationFlowDescriptor`
A class used to describe flow descriptors for `NameIDPrincipal` and `NameIdentifierPrincipal` c14n.

## Uses of SubjectCanonicalizationFlowDescriptor in net.shibboleth.idp.saml.nameid.impl

Subclasses of SubjectCanonicalizationFlowDescriptor in net.shibboleth.idp.saml.nameid.impl
Modifier and Type
Class
Description
`class`
`NameIDCanonicalization`
A `SubjectCanonicalizer` that transforms the input `Subject` into a principal name by searching for one and only one `NameIDPrincipal` custom principal, using an injected `NameIDDecoder` to carry out the process.
`class`
`NameIdentifierCanonicalization`
A `SubjectCanonicalizer` that transforms the input `Subject` into a principal name by searching for one and only one `NameIdentifierPrincipal` custom principal, using an injected `NameIdentifierDecoder` to carry out the process.